texture<unsigned int, 2, cudaReadModeElementType> tex;
__global__ void filter(unsigned int* result, const int M, const int N, const float sigma_d, const float sigma_r)
{
  const int i = threadIdx.x + blockDim.x * blockIdx.x;
  const int j = threadIdx.y + blockDim.y * blockIdx.y;
  if ((i < M) && (j < N)) {
      float s = 0;
      float c = 0;
      for (int l = i - 1; l <= i + 1; l++){
        for (int k = j - 1; k <= j + 1; k++){
          float img1 = tex2D(tex, k, l) / 255;
          float img2 = tex2D(tex, i, j) / 255;
          float g = exp(-(pow(k - i, 2) + pow(l - j, 2)) / pow(sigma_d, 2));
          float r = exp(-pow((img1 - img2) * 255, 2) / pow(sigma_r, 2));
          c += g * r;
          s += g * r * tex2D(tex, k, l);
        }
      }
      result[i * N + j] = s / c;
  }
}
